## libmpikmeans 1.5

=== Makefile ===
#
# Choose your compiler
#
# 

#CC = gcc-4.2
#CPP = g++-4.2
#CFLAGS=-O3 -ffast-math -fomit-frame-pointer -fPIC -mtune=k8 -march=k8 -Werror
CC = gcc-4.1
CPP = g++-4.1
CFLAGS=-O3 -ffast-math -fomit-frame-pointer -fPIC -Werror
#CC=/agbs/share/sw/icc/bin/icc
#CFLAGS= -fast -DCOMPILE_WITH_ICC -Werror

#
# MPI KMEANS FLAGS
#
VERBOSEFLAG=-DKMEANS_VERBOSE=0 # 0: silent, 1:iteration counter, 2:everything
#PRECISION=-DINPUT_TYPE=0 # 0: double, 1:float 

#
# MATLAB
#
MATLABDIR=/agbs/share/sw/matlab
MATLAB_INCLUDE=-I$(MATLABDIR)/extern/include

#
# BOOST LIBS (for standalone only)
#
BOOST_LIB=-L/kyb/agbs/pgehler/lib -lboost_program_options-gcc41-mt -lboost_filesystem-gcc41-mt -lboost_system-gcc41-mt
BOOST_INCLUDE=-I/kyb/agbs/pgehler/include/boost-1_36/

#
# PYTHON
#
PYTHON_INCLUDE=-I/usr/include/python2.5
PYTHON_LIB=-lpython2.5
NUMPY_INCLUDE=-I/usr/lib/python2.5/site-packages/numpy/core/include

#
# ARCHITECURE
# 

# 32 bit
SUFFIX=mexglx
MATLAB_LIB=-L$(MATLABDIR)/bin/glnx86 -lmex

# 64 bit
#SUFFIX=mexa64
#MATLAB_LIB=-L$(MATLABDIR)/bin/glnxa64 -lmex

LIBS=/usr/lib/gcc/i486-linux-gnu/4.1/libstdc++.a /usr/lib/libm.a

all: standalone matlab libmpikmeans python
matlab: 	mpi_kmeans_mex.$(SUFFIX) mpi_assign_mex.$(SUFFIX)
standalone:	mpi_kmeans_main mpi_assign_main
python:	cython_wrapper

mpi_kmeans.o:	mpi_kmeans.cxx mpi_kmeans.h
	$(CC) $(CFLAGS) $(VERBOSEFLAG) $(PRECISION) -c -o $@ mpi_kmeans.cxx

libmpikmeans:	mpi_kmeans.o
	ar rc libmpikmeans.a mpi_kmeans.o
	ranlib libmpikmeans.a
	$(CC) -shared -Wl,-soname=libmpikmeans.so -fPIC $(CFLAGS) -o libmpikmeans.so $(VERBOSEFLAGS) $(PRECISION) mpi_kmeans.cxx

mpi_kmeans_main.o:	mpi_kmeans_main.cxx
	$(CC) $(CFLAGS) $(BOOST_INCLUDE) -c -o mpi_kmeans_main.o mpi_kmeans_main.cxx 

mpi_assign_main.o:	mpi_assign_main.cxx
	$(CC) $(CFLAGS) $(BOOST_INCLUDE) -c -o mpi_assign_main.o mpi_assign_main.cxx 

mpi_kmeans_main:	libmpikmeans mpi_kmeans_main.o
	$(CC) mpi_kmeans_main.o  $(CFLAGS) -L/usr/lib/ -static -o mpi_kmeans -lm libmpikmeans.a \
		$(BOOST_LIB) $(LIBS)

mpi_assign_main:	libmpikmeans mpi_assign_main.o
	$(CC) mpi_assign_main.o  $(CFLAGS) -L/usr/lib/ -static -o mpi_assign -lm libmpikmeans.a \
		$(BOOST_LIB) $(LIBS)

%_mex.o:	%_mex.cxx
	$(CC) $(CFLAGS) $(MATLAB_INCLUDE) $(VERBOSEFLAG) $(PRECISION) -c $^ -o $@

mpi_kmeans_mex.$(SUFFIX):	libmpikmeans mpi_kmeans_mex.o 
	$(CC) mpi_kmeans_mex.o -shared -o mpi_kmeans_mex.$(SUFFIX) libmpikmeans.a $(MATLAB_LIB) 

mpi_assign_mex.$(SUFFIX):	libmpikmeans mpi_assign_mex.o
	$(CC) mpi_assign_mex.o -shared -o mpi_assign_mex.$(SUFFIX) libmpikmeans.a $(MATLAB_LIB)

cython_wrapper:	py_kmeans.c mpi_kmeans.o
	$(CPP) $(CFLAGS) $(PYTHON_INCLUDE) $(NUMPY_INCLUDE) -c -o py_kmeans.o py_kmeans.c
	$(CPP) $(CFLAGS) $(PYTHON_LIB) -lm -pthread -shared py_kmeans.o mpi_kmeans.o  -o py_kmeans.so 

test:	
	matlab -nojvm -r "test_code;exit"

clean:	
	rm -f *.o
	rm -f *.mexglx
	rm -f *.mexa64
	rm -f libmpikmeans.so
	rm -f libmpikmeans.a
	rm -f mpi_assign mpi_kmeans

=== debian/changelog ===
libmpikmeans (1.5-1build3) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 15:40:08 +0100

libmpikmeans (1.5-1build2) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:42 +0100

libmpikmeans (1.5-1build1) quantal; urgency=low

  *  No change rebuild against boost1.49

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 11 Jun 2012 02:51:39 +0100

libmpikmeans (1.5-1) unstable; urgency=low

  * Initial release (Closes: #622275)
  * debian/patches:
    - 0001-Properly-build-shared-and-static-libraries-programs
    - 0002-Drop-unused-option
    - 0003-Correct-command-name-in-help

 -- Christian Kastner <debian@kvr.at>  Wed, 13 Apr 2011 00:07:57 +0200

=== debian/control ===
Source: libmpikmeans
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christian Kastner <debian@kvr.at>
Build-Depends:
    debhelper (>= 7.0.50~),
    python-support (>= 0.90),
    python-all-dev,
    cython,
    python-numpy,
    libboost-dev,
    libboost-filesystem-dev,
    libboost-program-options-dev
Standards-Version: 3.9.2
Homepage: http://mloss.org/software/view/48/
Vcs-Git: git://scm.kvr.at/git/pkg-libmpikmeans.git
Vcs-Browser: http://scm.kvr.at/git//?p=pkg-libmpikmeans.git;a=summary

Package: libmpikmeans-dev
Section: libdevel
Architecture: any
Depends:
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version})
Description: Development libraries and header files for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the header files and static libraries.

Package: libmpikmeans1
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Description: Fast Library for k-means Clustering
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the shared libraries.

Package: libmpikmeans-dbg
Section: debug
Architecture: any
Depends:
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version})
Description: Debugging symbols for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the debugging symbols.

Package: mpikmeans-tools
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version})
Description: Standalone applications for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the standalone applications.

Package: python-mpikmeans
Section: python
Architecture: any
Depends:
    ${python:Depends},
    ${shlibs:Depends},
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version}),
    python-numpy
Description: Python bindings for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the Python bindings. Both the old, ctypes-based and the
 new, Cython-based interfaces are provided.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get version numbers for SONAME from changelog
DVER = $(shell dpkg-parsechangelog | grep '^Version')
LVER = $(shell echo $(DVER) | sed -e 's/Version: \([0-9]*\)\..*/\1/')
LSUBVER = $(shell echo $(DVER) | sed -e 's/Version: .*\.\([0-9]*\).*/\1/')
export LVER
export LSUBVER

# Python versions supported by this package
PYVERS = $(shell pyversions -r -v)
export PYVERS

CFLAGS += -Wall -Wno-unused


%:
	dh $@ 

override_dh_auto_build:
	make lib
	make standalone
	for py in $(PYVERS); do \
		PYVER=$$py make python; \
	done

override_dh_strip:
	dh_strip --dbg-package=libmpikmeans-dbg
	
	# Rename pyshared to pymodules
	cd debian/libmpikmeans-dbg/usr/lib/debug/usr/lib && mv pyshared pymodules

## libmpikmeans 1.5%2Bdfsg

=== debian/changelog ===
libmpikmeans (1.5+dfsg-5build3) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:18:37 +0000

libmpikmeans (1.5+dfsg-5build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:26:33 +0000

libmpikmeans (1.5+dfsg-5build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:20:42 +0000

libmpikmeans (1.5+dfsg-5) unstable; urgency=medium

  * Drop package libmpikmeans-dbg in favor of automatic dbgsym packages as per
    https://lists.debian.org/debian-devel/2015/12/msg00262.html
  * d/control:
    - Bump Standards-Version to 3.9.8 (no changes needed)
    - Add dh-python to Build-Depends
    - Switch Maintainer email to my @debian.org address
    - Switch Vcs-Browser from gitweb to cgit
    - Replace Vcs-* insecure URIs with secure ones
  * d/rules:
    - Drop unnecessary inclusion of buildflags.mk
    - Fix missing export of DEB_CFLAGS_MAINT_APPEND
    - Add hardening=+all to DEB_BUILD_MAINT_OPTIONS
    - Simplify version parsing
  * d/patches:
    - Drop patch numbers from .patch filenames
  * d/gbp.conf:
    - Update for patches without numbers
  * d/patches (updated):
    - Properly-build-shared-and-static-libraries-programs
      Filter out -pie, -fpie, and -fPIE when building the shared library
  * d/copyright:
    - Bump copyright years

 -- Christian Kastner <ckk@debian.org>  Sun, 24 Apr 2016 15:22:33 +0200

libmpikmeans (1.5+dfsg-4) unstable; urgency=medium

  * debian/control:
    - Bump Standards-Version to 3.9.6 (no changes needed)
    - Drop XS-Testsuite. dpkg now recognizes the Testsuite header, and
      dpkg-source automatically adds one when an autopkgtest suite is found
  * debian/copyright:
    - Bump copyright years

 -- Christian Kastner <debian@kvr.at>  Sat, 18 Jul 2015 17:34:17 +0200

libmpikmeans (1.5+dfsg-3) unstable; urgency=medium

  * Migrate git repo to Debian-Science at git.debian.org
  * debian/control:
    - Update Vcs-* URLs to point to new location
    - control: Add XS-Testsuite
  * debian/tests/*:
    - Define an autopkgtest that runs the examples from the documentation

 -- Christian Kastner <debian@kvr.at>  Mon, 25 Aug 2014 11:39:08 -0700

libmpikmeans (1.5+dfsg-2) unstable; urgency=low

  * debian/control:
    - Add Multi-Arch fields to packages where necessary
    - Add Pre-Depends for package liblinear1
  * debian/rules:
    - Install to multi-arch locations
  * debian/*.install:
    - Update paths as a consequence of the new install target and
      multi-arch-ification
  * debian/patches (updated):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Add an install target to upstream's Makefile, with configurable
      destinations for libraries and executables

 -- Christian Kastner <debian@kvr.at>  Sun, 27 Jul 2014 01:13:16 +0200

libmpikmeans (1.5+dfsg-1) unstable; urgency=low

  * Fixed upstream version number (indicate DFSG-cleaned upstream source)
  * Bumped Standards-Version to 3.9.5 (no changes needed)
  * Bumped debhelper compatibility level to 9
    - No longer manually move debugging symbols files from broken locations
      (pyshared / pymodules), dh_strip now uses build-id
  * Converted to dh_python2
    - Added X-Python-Version >= 2.5 to debian/control
    - Removed obsolete debian/pyversions
    - Added python2 to dh sequence to debian/rules
  * Updated debian/rules to make use of dpkg-buildflags, for hardening
  * Updated debian/copyright to machine-readable format v1.0
  * Created debian/gbp.conf (package is based on dfsg, not upstream)
  * Let libmpikmeans1 Suggest libmpikmeans-tools
  * Moved examples from package libmpikmeans1 to mpikmeans-tools
  * lintian:
    - Added override for debian-watch-file-is-missing
  * debian/patches (modified):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Fixed missing/wrong build flags

 -- Christian Kastner <debian@kvr.at>  Fri, 21 Feb 2014 12:17:57 +0100

## libmpikmeans 1.5+dfsg

=== debian/changelog ===
libmpikmeans (1.5+dfsg-8) unstable; urgency=medium

  * d/rules: override_dh_missing for --fail-missing
  * d/control:
    - Bump Standards-Version to 4.4.1 (no changes needed)
    - Set Rules-Requires-Root to no to declare that libfann does not need
      (fake)root for building its debs
  * Let dh_install install from debian/tmp, instead of source
    Resolves a warning from dh_missing. Thanks, Niels Thykier, for the analysis and
    resolution!

 -- Christian Kastner <ckk@debian.org>  Mon, 14 Oct 2019 21:39:18 +0200

libmpikmeans (1.5+dfsg-7) unstable; urgency=medium

  * Correct broken Vcs-* fields (copy-pasta)
  * Drop d/*.dirs, the dh_* helpers create directories as needed
  * Move our custom manpages from d/ to d/man/
  * d/source/lintian-overrides:
    - Fix syntax issue
    - Add tag debian-watch-file-is-missing
      Upstream only provides a link to the current, unversioned download
  * gbp.conf: Get rid of the 'dfsg' branch
    Until now, the original upstream source was on branch 'upstream' and the
    DFSG-cleaned source on branch 'dfsg'. This has little to no benefit, but
    many downsides: it departs from common Debian workflows, and also
    represents extra maintenance work

 -- Christian Kastner <ckk@debian.org>  Mon, 18 Feb 2019 19:47:28 +0100

libmpikmeans (1.5+dfsg-6) unstable; urgency=medium

  * Point Vcs-* to Salsa
  * Switch to https in Homepage field
  * Switch Build-Depends from debhelper to debhelper-compat
  * Bump Build-Depends for debhelper-compat to 12
  * Remove now obsolete d/compat
  * Drop ancient X-Python-Version
  * Reduce Priority to optional as per Policy 4.0.1
  * Bump Standards-Version to 4.3.0
  * d/rules:
    - Drop override_dh_strip
      It was only needed for the dbgsym migration
    - Use DEB_VERSION from dpkg/pkg-info.mk instead of parsing d/changelog
  * d/source/lintian-overrides
    - Remove tag debian-watch-file-is-missing, it has been re-classified as
      experimental
    - Add tag python-foo-but-no-python3-foo
  * gbp.conf:
    - Add pristine-tar, sign-tags options
    - Set upstream branch to dfsg
  * d/copyright: Switch to https in Format field
  * d/tests: Rename ADTTMP to AUTOPKGTEST_TMP
  * d/libmpikmeans.symbols: Add Build-Depends-Package field

 -- Christian Kastner <ckk@debian.org>  Wed, 13 Feb 2019 21:21:27 +0100

=== debian/control ===
Source: libmpikmeans
Section: libs
Priority: optional
Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper-compat (= 12),
    dh-python,
    python-all-dev (>= 2.6.6-3~),
    cython,
    python-numpy,
    libboost-dev,
    libboost-filesystem-dev,
    libboost-program-options-dev,
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: https://mloss.org/software/view/48/
Vcs-Git: https://salsa.debian.org/science-team/libmpikmeans.git
Vcs-Browser: https://salsa.debian.org/science-team/libmpikmeans

Package: libmpikmeans-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version}),
Description: Development libraries and header files for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the header files and static libraries.

Package: libmpikmeans1
Architecture: any
Multi-Arch: same
Pre-Depends:
    ${misc:Pre-Depends},
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Suggests:
    mpikmeans-tools (= ${binary:Version}),
Description: Fast Library for k-means Clustering
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the shared libraries.

Package: mpikmeans-tools
Architecture: any
Multi-Arch: foreign
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version}),
Description: Standalone applications for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the standalone applications.

Package: python-mpikmeans
Section: python
Architecture: any
Depends:
    ${python:Depends},
    ${shlibs:Depends},
    ${misc:Depends},
    libmpikmeans1 (= ${binary:Version}),
    python-numpy,
Description: Python bindings for MPIKmeans
 This library uses an algorithm that yields the very same solution as standard
 k-means, even after each iteration. However, it uses triangle inequalities, and
 is much faster.
 .
 Note: MPI here does not refer to the Message Passing Interface; rather, it is
 an acronym for Max Planck Institute, where this algorithm was developed.
 .
 This package contains the Python bindings. Both the old, ctypes-based and the
 new, Cython-based interfaces are provided.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# Get version numbers for SONAME from changelog
LVER =    $(shell echo $(DEB_VERSION) | sed -e 's/\([0-9]*\)\..*/\1/')
LSUBVER = $(shell echo $(DEB_VERSION) | sed -e 's/.*\.\([0-9]*\).*/\1/')
export LVER
export LSUBVER

# Python versions supported by this package
PYVERS = $(shell pyversions -r -v)
export PYVERS

# Extend build flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -Wall -Wno-unused

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@ --with python2

override_dh_auto_build:
	make lib
	make standalone
	for py in $(PYVERS); do \
		PYVER=$$py make python; \
	done

override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_missing:
	dh_missing --fail-missing
